CF733C Epidemic in Monstropolis[模拟 构造 贪心]
1 second
256 megabytes
standard input
standard output
There was an epidemic in Monstropolis and all monsters became sick. To recover, all monsters lined up in queue for an appointment to the only doctor in the city.
Soon, monsters became hungry and began to eat each other.
One monster can eat other monster if its weight is strictly greater than the weight of the monster being eaten, and they stand in the queue next to each other. Monsters eat each other instantly. There are no monsters which are being eaten at the same moment. After the monsterA eats the monster B, the weight of the monster A increases by the weight of the eaten monster B. In result of such eating the length of the queue decreases by one, all monsters after the eaten one step forward so that there is no empty places in the queue again. A monster can eat several monsters one after another. Initially there were n monsters in the queue, the i-th of which had weight ai.
For example, if weights are [1, 2, 2, 2, 1, 2] (in order of queue, monsters are numbered from 1 to 6 from left to right) then some of the options are:
- the first monster can't eat the second monster because a1 = 1 is not greater than a2 = 2;
- the second monster can't eat the third monster because a2 = 2 is not greater than a3 = 2;
- the second monster can't eat the fifth monster because they are not neighbors;
- the second monster can eat the first monster, the queue will be transformed to [3, 2, 2, 1, 2].
After some time, someone said a good joke and all monsters recovered. At that moment there were k (k ≤ n) monsters in the queue, the j-th of which had weight bj. Both sequences (a and b) contain the weights of the monsters in the order from the first to the last.
You are required to provide one of the possible orders of eating monsters which led to the current queue, or to determine that this could not happen. Assume that the doctor didn't make any appointments while monsters were eating each other.
The first line contains single integer n (1 ≤ n ≤ 500) — the number of monsters in the initial queue.
The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 106) — the initial weights of the monsters.
The third line contains single integer k (1 ≤ k ≤ n) — the number of monsters in the queue after the joke.
The fourth line contains k integers b1, b2, ..., bk (1 ≤ bj ≤ 5·108) — the weights of the monsters after the joke.
Monsters are listed in the order from the beginning of the queue to the end.
In case if no actions could lead to the final queue, print "NO" (without quotes) in the only line.
Otherwise print "YES" (without quotes) in the first line. In the next n - k lines print actions in the chronological order. In each line print x — the index number of the monster in the current queue which eats and, separated by space, the symbol 'L' if the monster which stays the x-th in the queue eats the monster in front of him, or 'R' if the monster which stays the x-th in the queue eats the monster behind him. After each eating the queue is enumerated again.
When one monster eats another the queue decreases. If there are several answers, print any of them.
6
1 2 2 2 1 2
2
5 5
YES
2 L
1 R
4 L
3 L
5
1 2 3 4 5
1
15
YES
5 L
4 L
3 L
2 L
5
1 1 1 3 3
3
2 1 6
NO
In the first example, initially there were n = 6 monsters, their weights are [1, 2, 2, 2, 1, 2] (in order of queue from the first monster to the last monster). The final queue should be [5, 5]. The following sequence of eatings leads to the final queue:
- the second monster eats the monster to the left (i.e. the first monster), queue becomes [3, 2, 2, 1, 2];
- the first monster (note, it was the second on the previous step) eats the monster to the right (i.e. the second monster), queue becomes[5, 2, 1, 2];
- the fourth monster eats the mosnter to the left (i.e. the third monster), queue becomes [5, 2, 3];
- the finally, the third monster eats the monster to the left (i.e. the second monster), queue becomes [5, 5].
Note that for each step the output contains numbers of the monsters in their current order in the queue.
题意:相邻的数值不同可以互相吃,吃掉后数值相加,编号重新排,问能不能从a序列吃成b序列,并输出一个吃的顺序
官方题解:
The key observation to solution is to notice that b1 is union (monsters eat one another one by one in such a way that only one is being left) of elements of some prefix of a. And if you remove this prefix and first element of b then this condition will remain true for new arraysa and b.
Answer is "NO" when:
- There is no such prefix that has sum of bi.
- Prefix of sum bi consists of equal elements and its size > 1.
Now let's consider certain prefix. Our goal is to find sequence of moves to get only one monster left.
Here is one of possible solutions:
- Find such i that ai is maximum in prefix and either ai - 1 or ai + 1 is strictly less that ai.
- Eat any of possible neighbors.
- If only one monster is left then move to next segment.
- If all weights become equal then print "NO".
The only thing left is to carefully calculate real positions of monsters on each step.
Also you can't output them at a moment of calculation as there might be a "NO" answer afterwards.
Time complexity — O(n2).
其实就是发现当前b首是由a的一个前缀和组成的,对于每个b[i]找a的一段然后打印就行了
打印时贪心选择最大的然后吃就行了,吃到剩下一个
对于前缀和不能相同的处理print已经保证了
需要注意最后a还剩下一些
感觉写起来挺顺利的,一些情况也想到怎么处理了
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>
using namespace std;
const int N=,INF=1e9+;
inline int read(){
char c=getchar();int x=,f=;
while(c<''||c>''){if(c=='-')f=-;c=getchar();}
while(c>=''&&c<=''){x=x*+c-'';c=getchar();}
return x*f;
}
int n,a[N],s[N],m,b[N];
int t[N];
struct eat{
int id;
char s;
}ans[N];
int cnt=,fail=;
void print(int n,int a[],int id){//printf("print %d %d\n",n,id);
while(n>){
int mx=-,p=-;
for(int i=;i<=n;i++)
if(a[i]>mx&& ((i!=&&a[i-]<a[i]) || (i!=n&&a[i+]<a[i])) ) mx=a[i],p=i;
if(p==-){fail=;return;} cnt++;ans[cnt].id=id+p;
if(p!=&&a[p-]<a[p]){
ans[cnt].s='L';
a[p-]+=a[p];n--;
for(int i=p;i<=n;i++) a[i]=a[i+];
}else{
ans[cnt].s='R';
a[p]+=a[p+];n--;
for(int i=p+;i<=n;i++) a[i]=a[i+];
}
}
}
void sol(){
for(int i=;i<=n;i++) s[i]=s[i-]+a[i]; int j=;
for(int i=;i<=m;i++){//printf("sol i %d\n",i);
int s=,p=;
for(j++;j<=n;j++){//printf("sol j %d\n",j);
s+=a[j];t[++p]=a[j];
if(s>=b[i]) break;
}
if(s!=b[i]){printf("NO");return;} print(p,t,i-);
if(fail){printf("NO");return;}
}
if(j<n) {puts("NO");return;}//! puts("YES");
for(int i=;i<=cnt;i++) printf("%d %c\n",ans[i].id,ans[i].s);
}
int main(){
n=read();
for(int i=;i<=n;i++) a[i]=read();
m=read();
for(int i=;i<=m;i++) b[i]=read();
sol();
}
CF733C Epidemic in Monstropolis[模拟 构造 贪心]的更多相关文章
- Codeforces Round #378 (Div. 2) C. Epidemic in Monstropolis 模拟
C. Epidemic in Monstropolis time limit per test 1 second memory limit per test 256 megabytes input s ...
- Codeforces 733C:Epidemic in Monstropolis(暴力贪心)
http://codeforces.com/problemset/problem/733/C 题意:给出一个序列的怪兽体积 ai,怪兽只能吃相邻的怪兽,并且只有体积严格大于相邻的怪兽才能吃,吃完之后, ...
- CodeForces - 1255D (模拟+构造+贪心)
题意 https://vjudge.net/problem/CodeForces-1255D rxc的农场里'R'表示有米,现在有K只鸡,给这k只鸡选一些格子,每个鸡可以有多个格子(每个鸡至少吃一个米 ...
- Epidemic in Monstropolis
Epidemic in Monstropolis 题目链接:http://codeforces.com/contest/733/problem/C 贪心 新序列的m个数肯定是由原序列的连续的m个子序列 ...
- 【16.52%】【codeforces 733C】Epidemic in Monstropolis
time limit per test1 second memory limit per test256 megabytes inputstandard input outputstandard ou ...
- Codeforces Round #378 (Div. 2)-C. Epidemic in Monstropolis
C. Epidemic in Monstropolis time limit per test 1 second memory limit per test 256 megabytes input s ...
- 学习xss模拟构造攻击(第一篇)
本文作者:i春秋签约作家——rosectow 0×00前言 XSS又名叫CSS全程(cross site scriptting),中文名跨站脚本攻击,目前网站的常见漏洞之一,它的危害没有像上传漏洞,s ...
- 5.5 省选模拟赛 B Permutation 构造 贪心
LINK:Permutation 对于这种构造神题 我自然是要补的.为啥就我没想出来哇. 30分还是很好写的 注意8!实际上很小 不需要爆搜 写bfs记录状态即可.至于判断状态是否出现与否 可以开ma ...
- codeforces733-C. Epidemic in Monstropolis 贪心加链表
题意 现在有一个怪兽序列a[i],权值大的怪兽可以吃权值小的怪兽,吃完之后权值大的怪兽的权值会变成两者权值的和,相邻的怪兽才能吃 吃完之后,位置合并,队列前移,从左到右重新编号,重复这一过程, 然后给 ...
随机推荐
- ym—— Android网络框架Volley(体验篇)
VolleyGoogle I/O 2013推出的网络通信库,在volley推出之前我们一般会选择比较成熟的第三方网络通信库,如: android-async-http retrofit okhttp ...
- Differences between INDEX, PRIMARY, UNIQUE, FULLTEXT in MySQL?
487down vote Differences KEY or INDEX refers to a normal non-unique index. Non-distinct values for ...
- JAVA 链表操作:循环链表
主要分析示例: 一.循环链表简述 二.单链表循环链表 三.双链表循环链表 一.循环链表简述 循环链表即链表形成了一个循环的结构,尾节点不再指向NULL,而是指向头节点HEAD,此时判定链表的结束是尾节 ...
- entityframework学习笔记--003-使用model first
首先,我个人觉得这(model first 即模型优先)是一个鸡肋似的功能.当赞扬着他的强大的功能的同时,你也会觉得这个功能好像是不是不怎么需要,也很少使用. 1.右键你的项目,选择"添加& ...
- Java基础学习总结 -- 多线程的实现
目录: 继承Thread类 start()方法实现多线程的原理 实现Runnable接口 Thread类 与 Runnable接口 的联系与区别 多线程的实现方法: 继承Thread类 实现Runna ...
- 《More Effective C#》读书笔记
<More Effective C#>这本书,大概是四年前看完的,但只整理了一部分读书笔记,后面有时间的话,会陆续补充的. More Effective C# :使用泛型 More Eff ...
- 从“黑掉Github”学Web安全开发
Egor Homakov(Twitter: @homakov 个人网站: EgorHomakov.com)是一个Web安全的布道士,他这两天把github给黑了,并给github报了5个安全方面的bu ...
- 【HTML DOM】Node.nodeValue的用法
目录结构: // contents structure [-] 语法 注意 详述 实例 参考文章 Note.noteValue 属性返回或设置当前属性的值. 语法 value = node.nodeV ...
- GIS公交查询-flex/java
开发语言是flex.java,开发平台是myeclise.eclise,开发接口是arcgis api for flex,提供以下的功能: 1.站名-站名查询: 2.站点查询: 3.路线查询: 备注: ...
- iOS 隐藏自定义tabbar
iOS 隐藏自定义tabbar -(void)viewWillAppear:(BOOL)animated { NSArray *array=self.tabBarController.view.su ...